
     .title  'Disk "LED" Indicator'

;---------------------------------------------------------------------
;                                                                    :
;    Silly "Disk LED" program  (disk activity indicator)             :
;    Landon Dyer, Atari Corp.                                        :
;                                                                    :
;----------------                                                    :
;  9-Nov-1986 atari!dyer     Hacked it up.  You need MADMAC to       :
;                            assemble it, though....                 :
;                                                                    :
;---------------------------------------------------------------------
     .include atari                  ; Atari ST equates and macros

     Physbase                        ; d0 -> screen base
     add.l   #(200*160)-16,d0        ; compute addr of longword
     move.l  d0,stuffSpot            ;       and save it
     clr.w   flipstate
     Supexec #install                ; install our installer

     move.l  4(sp),a0                ; compute size to Ptermres
     move.l  $c(a0),d0
     add.l   $14(a0),d0
     add.l   $1c(a0),d0
     add.l   #$100,d0

     Ptermres d0,#0                  ; terminate and stay resident


;----------------
;
;    Rwabs() intercept
;    o  save return address
;    o  setup to return to ret_handler
;    o  turn on the indicator
;    o  follow through old Rwabs() vector
;
handler:
     move.l  (sp),ret_addr           ; save return address
     move.l  #ret_handler,(sp)       ; arrange return to ret_handler

     move.b  shiftmd,d1              ; d1 = resolution&3
     and.w   #$0003,d1
     move.w  flipstate,d2            ; eor-in flip state
     eor.w   d2,d1
     add.w   d1,d1                   ; d1 = wordIndex(d1)
     move.w  reztab(pc,d1.w),d1      ; get offset

     move.l  stuffSpot,a0            ; turn on the indicator
     move.w  4(sp),d2                ; get read/write mode
     and.w   #1,d2
     add.w   d2,d2
     add.w   d2,d2
     move.l  indic(pc,d2.w),(a0,d1.w) ; stuff bar into screen ram

     move.l  old_rw,a0               ; follow through to
     jmp     (a0)                    ;       original handler


;----------------
;
;    Rwabs return intercept
;    o  turn off the indicator
;    o  flip indicator offset
;    o  return to original caller
;
ret_handler:
     move.b  shiftmd,d1              ; d1 = resolution&3
     and.w   #$0003,d1
     move.w  flipstate,d2            ; eor-in flip offset
     eor.w   d2,d1
     add.w   d1,d1                   ; d1 = wordIndex(d1)
     move.w  reztab(pc,d1.w),d1      ; get offset

     move.l  stuffSpot,a0            ; turn off the indicator
     clr.l   (a0,d1.w)
     eor.w   #%100,flipstate         ; flip screen offset

     move.l  ret_addr,a0             ; return to original caller
     jmp     (a0)

;
;  Offsets into stuffSpot[] for low, medium and high rez
;
reztab:
     dc.w    12,12,12,12
     dc.w    4,8,8,8

indic:
     dc.l    $ffffffff               ; read (solid)
     dc.l    $f0f0f0f0               ; write (dashed)


;----------------
;
;    Rwabs() intercept installer
;
install:
     move.l  hdv_rw,old_rw           ; save old vector
     move.l  #handler,hdv_rw         ; install our new one
     rts


    .bss

stuffSpot:   ds.l    1               ; -> indicator
old_rw:      ds.l    1               ; = original hdv_rw vector
ret_addr:    ds.l    1               ; = caller's return address
flipstate:   ds.w    1               ; = flip state

     end

